//=======================================================================================
//(C)nyankosan　2015-06-12
//=======================================================================================

//============================================================================
//牌画を操作するための配列：JSON形式
//============================================================================
var paigaType = [
	{"No":0,"paiName":"一萬","cssSprite":"man1","paigaNo":1},
	{"No":1,"paiName":"二萬","cssSprite":"man2","paigaNo":2},
	{"No":2,"paiName":"三萬","cssSprite":"man3","paigaNo":3},
	{"No":3,"paiName":"四萬","cssSprite":"man4","paigaNo":4},
	{"No":4,"paiName":"赤五萬","cssSprite":"man0","paigaNo":0},
	{"No":5,"paiName":"五萬","cssSprite":"man5","paigaNo":5},
	{"No":6,"paiName":"六萬","cssSprite":"man6","paigaNo":6},
	{"No":7,"paiName":"七萬","cssSprite":"man7","paigaNo":7},
	{"No":8,"paiName":"八萬","cssSprite":"man8","paigaNo":8},
	{"No":9,"paiName":"九萬","cssSprite":"man9","paigaNo":9},

	{"No":10,"paiName":"一筒","cssSprite":"pin1","paigaNo":11},
	{"No":11,"paiName":"二筒","cssSprite":"pin2","paigaNo":12},
	{"No":12,"paiName":"三筒","cssSprite":"pin3","paigaNo":13},
	{"No":13,"paiName":"四筒","cssSprite":"pin4","paigaNo":14},
	{"No":14,"paiName":"赤五筒","cssSprite":"pin0","paigaNo":10},
	{"No":15,"paiName":"五筒","cssSprite":"pin5","paigaNo":15},
	{"No":16,"paiName":"六筒","cssSprite":"pin6","paigaNo":16},
	{"No":17,"paiName":"七筒","cssSprite":"pin7","paigaNo":17},
	{"No":18,"paiName":"八筒","cssSprite":"pin8","paigaNo":18},
	{"No":19,"paiName":"九筒","cssSprite":"pin9","paigaNo":19},

	{"No":20,"paiName":"一索","cssSprite":"sou1","paigaNo":21},
	{"No":21,"paiName":"二索","cssSprite":"sou2","paigaNo":22},
	{"No":22,"paiName":"三索","cssSprite":"sou3","paigaNo":23},
	{"No":23,"paiName":"四索","cssSprite":"sou4","paigaNo":24},
	{"No":24,"paiName":"赤五索","cssSprite":"sou0","paigaNo":20},
	{"No":25,"paiName":"五索","cssSprite":"sou5","paigaNo":25},
	{"No":26,"paiName":"六索","cssSprite":"sou6","paigaNo":26},
	{"No":27,"paiName":"七索","cssSprite":"sou7","paigaNo":27},
	{"No":28,"paiName":"八索","cssSprite":"sou8","paigaNo":28},
	{"No":29,"paiName":"九索","cssSprite":"sou9","paigaNo":29},

	{"No":30,"paiName":"裏","cssSprite":"ji0","paigaNo":30},
	{"No":31,"paiName":"東","cssSprite":"ji1","paigaNo":31},
	{"No":32,"paiName":"南","cssSprite":"ji2","paigaNo":32},
	{"No":33,"paiName":"西","cssSprite":"ji3","paigaNo":33},
	{"No":34,"paiName":"北","cssSprite":"ji4","paigaNo":34},
	{"No":35,"paiName":"白","cssSprite":"ji5","paigaNo":35},
	{"No":36,"paiName":"發","cssSprite":"ji6","paigaNo":36},
	{"No":37,"paiName":"中","cssSprite":"ji7","paigaNo":37}
];

//============================================================================
//グローバル変数
//============================================================================
var PaiCount = 0;	//入力された牌の枚数
var PaiNo = [];//牌画表示用
//============================================================================
//牌画を挿入する関数
//============================================================================
$("span","#haiga").on('click', function(event){
	var paiCountMax = 14;//手牌最大数
	var paiNo = $(this).attr("name"); //牌の番号を取得
	var paiName = $(this).attr("class"); //CSSスプライト用のクラス名を取得
	if(PaiCount<paiCountMax){
		if(tehai[paiNo]==4||tehai[5]+tehai[0]==4||tehai[15]+tehai[10]==4||tehai[25]+tehai[20]==4){
			alert("同種牌を5枚以上入力することはできません。");
			return false;
		}else{
			if(paiNo===0&&red5manCount==1||paiNo==10&&red5pinCount==1||paiNo==20&&red5souCount==1){
				alert("赤ドラは各色1枚までです。");
				return false;
			}
			tehai[paiNo] ++;//手牌
			if(paiNo%10===0){checkReddora();}//赤ドラのチェック
			//PaiNo[PaiCount] = paiNo;//表示用手牌
			PaiNo[PaiCount] = paiType[paiNo].paigaNo;//表示用手牌
			paiSet(PaiCount,paiName);//牌画を表示させる関数を呼び出す
			PaiCount ++;
			$("#paikazu").empty().append(PaiCount);
		}
	}else{
		alert("これ以上は牌を置けません。");
		return false;
	}
});
//============================================================================
//牌を配置する関数
//============================================================================
function paiSet(i,paiName) {
	paiga = "<span class=\"" + paiName + "\"></span>";//cssスプライトの牌画を配置
	var putNo = "#pai" + i;
	$(putNo ,"#paisu").append(paiga);
	return;
}
//============================================================================
//任意の牌を1つ消す処理
//============================================================================
$("td","#paisu").click(function() {
var tdNo = $(this).attr("id"); //牌画を配置したセルのIDを取得
	var paikazu = PaiNo.length;
	if(paikazu === 0){
		alert("これ以上牌を消せません");
		return;
	}else{
		tdNo = tdNo.slice(3,5);//削って番号のみにする
		if(PaiNo[tdNo]==4){red5manCount--;}
		if(PaiNo[tdNo]==14){red5pinCount--;}
		if(PaiNo[tdNo]==24){red5souCount--;}
		tehai[paigaType[PaiNo[tdNo]].paigaNo] --;//手牌
		if(tdNo < paikazu){
			$("td","#paisu").empty();
			PaiNo.splice(tdNo,1);
			for(var i=0;i<paikazu -1 ;i++){
				paiSet(i,paigaType[PaiNo[i]].cssSprite);
			}
		}
		PaiCount --;
		$("#paikazu").empty().append(PaiCount);
	}
});
//============================================================================
//手牌を並べ替える処理
//============================================================================
$("#PaiSortBtn").on('click', function(event){
	paiSort();
});
//============================================================================
//牌を並べ替える関数
//============================================================================
function paiSort() {
	//手牌を並び替える
	var paikazu = PaiNo.length;
	PaiNo.sort(function(b,c){
		return b - c;
	});
	$("td","#paisu").empty();
	for (var i = 0;i<paikazu ;i++){
		paiSet(i,paigaType[PaiNo[i]].cssSprite);
	}
	return;
}
//============================================================================
//リセット処理
//============================================================================
$("#PaiClreaBtn").on('click', function(event){
	resetTehai();
});
//============================================================================
//リセット関数
//============================================================================
function resetTehai(){
	tehai = [0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0];
	PaiNo.length = 0;//牌を格納した配列の要素をすべて削除
	PaiCount = 0;//カウントのリセット
	$("#paikazu").empty().append("0");
	$("td","#paisu").empty();
	$("#paiKigou_MPS").empty();
	$("#paikigou_tenhou").empty();
	red5manCount = 0;//赤5マンの数
	red5pinCount = 0;//赤5ピンの数
	red5souCount = 0;//赤5ソウの数
}
//============================================================================
