//=======================================================================================
//(C)nyankosan　2015-06-12
//=======================================================================================

//============================================================================
//牌の配列：JSON形式
//============================================================================
var paiType = [
	{"No":0,"paiName":"赤五萬","cssSprite":"man0","paigaNo":4},
	{"No":1,"paiName":"一萬","cssSprite":"man1","paigaNo":0},
	{"No":2,"paiName":"二萬","cssSprite":"man2","paigaNo":1},
	{"No":3,"paiName":"三萬","cssSprite":"man3","paigaNo":2},
	{"No":4,"paiName":"四萬","cssSprite":"man4","paigaNo":3},
	{"No":5,"paiName":"五萬","cssSprite":"man5","paigaNo":5},
	{"No":6,"paiName":"六萬","cssSprite":"man6","paigaNo":6},
	{"No":7,"paiName":"七萬","cssSprite":"man7","paigaNo":7},
	{"No":8,"paiName":"八萬","cssSprite":"man8","paigaNo":8},
	{"No":9,"paiName":"九萬","cssSprite":"man9","paigaNo":9},

	{"No":10,"paiName":"赤五筒","cssSprite":"pin0","paigaNo":14},
	{"No":11,"paiName":"一筒","cssSprite":"pin1","paigaNo":10},
	{"No":12,"paiName":"二筒","cssSprite":"pin2","paigaNo":11},
	{"No":13,"paiName":"三筒","cssSprite":"pin3","paigaNo":12},
	{"No":14,"paiName":"四筒","cssSprite":"pin4","paigaNo":13},
	{"No":15,"paiName":"五筒","cssSprite":"pin5","paigaNo":15},
	{"No":16,"paiName":"六筒","cssSprite":"pin6","paigaNo":16},
	{"No":17,"paiName":"七筒","cssSprite":"pin7","paigaNo":17},
	{"No":18,"paiName":"八筒","cssSprite":"pin8","paigaNo":18},
	{"No":19,"paiName":"九筒","cssSprite":"pin9","paigaNo":19},

	{"No":20,"paiName":"赤五索","cssSprite":"sou0","paigaNo":24},
	{"No":21,"paiName":"一索","cssSprite":"sou1","paigaNo":20},
	{"No":22,"paiName":"二索","cssSprite":"sou2","paigaNo":21},
	{"No":23,"paiName":"三索","cssSprite":"sou3","paigaNo":22},
	{"No":24,"paiName":"四索","cssSprite":"sou4","paigaNo":23},
	{"No":25,"paiName":"五索","cssSprite":"sou5","paigaNo":25},
	{"No":26,"paiName":"六索","cssSprite":"sou6","paigaNo":26},
	{"No":27,"paiName":"七索","cssSprite":"sou7","paigaNo":27},
	{"No":28,"paiName":"八索","cssSprite":"sou8","paigaNo":28},
	{"No":29,"paiName":"九索","cssSprite":"sou9","paigaNo":29},

	{"No":30,"paiName":"裏","cssSprite":"ji0","paigaNo":30},
	{"No":31,"paiName":"東","cssSprite":"ji1","paigaNo":31},
	{"No":32,"paiName":"南","cssSprite":"ji2","paigaNo":32},
	{"No":33,"paiName":"西","cssSprite":"ji3","paigaNo":33},
	{"No":34,"paiName":"北","cssSprite":"ji4","paigaNo":34},
	{"No":35,"paiName":"白","cssSprite":"ji5","paigaNo":35},
	{"No":36,"paiName":"發","cssSprite":"ji6","paigaNo":36},
	{"No":37,"paiName":"中","cssSprite":"ji7","paigaNo":37}
];
//============================================================================
//グローバル変数
//============================================================================
var tehai = new Array(37);//手牌の配列：37種
tehai = [0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0];
var red5manCount = 0;//赤5マンの数
var red5pinCount = 0;//赤5ピンの数
var red5souCount = 0;//赤5ソウの数
//============================================================================
//赤ドラの有無をチェックする処理
//============================================================================
function checkReddora(){
	//グローバル変数の初期化
	red5manCount = 0;//赤5マンの数
	red5pinCount = 0;//赤5ピンの数
	red5souCount = 0;//赤5ソウの数

	//赤五萬の有無をチェックしてカウントする
	if(tehai[0]){
		red5manCount += tehai[0];//赤五萬の牌数を格納
	}
	//赤五筒の有無をチェックしてカウントする
	if(tehai[10]){
		red5pinCount += tehai[10];//赤五筒の牌数を格納
	}
	//赤五索の有無をチェックしてカウントする
	if(tehai[20]){
		red5souCount += tehai[20];//赤五索の牌数を格納
	}
}
//============================================================================
//牌記号を出力する処理
//============================================================================
$("#PaikigouMakeBtn").click(function() {
	var paikigou;

	//MPS形式の牌記号出力する
	paikigou = makeMpsPaikigou();
	$("#paiKigou_MPS").empty().append(paikigou);

	//天鳳牌理形式（MPSZ形式）の牌記号出力する
	paikigou = makeTenhouPakigou();
	$("#paikigou_tenhou").empty().append(paikigou);
});
//============================================================================
//天鳳の牌理で使われる牌記号（MPSZ形式）を生成する関数
//============================================================================
function makeTenhouPakigou(){
	var paiFlg = 0;//マンズ・ピンズ・ソウズ・字牌の有無をチェックするフラグ
	var paikigou="";
	var i,j;

	//マンズの牌記号を生成する
	for(i=1;i<10;i++){
		//赤五萬を配置する
		if(i==5 && red5manCount==1){//red5manCountはグローバル変数
			paikigou += "0";//赤ドラ
			paiFlg = 1;//マンズが存在するのでフラグを立てる
		}
		//赤五萬以外のマンズを配置する
		for(j=1;j<tehai[i]+1;j++){
			if(!tehai[i]){continue;}
			paikigou += i;
			paiFlg = 1;//マンズが存在するのでフラグを立てる
		}
	}
	if(paiFlg){
		paikigou += "m";//末尾に付ける文字
		paiFlg = 0;//フラグのリセット
	}

	//ピンズの牌記号を生成する
	for(i=11;i<20;i++){
		//赤五筒を配置する
		if(i==15 && red5pinCount==1){//red5pinCountはグローバル変数
			paikigou += "0";//赤ドラ
			paiFlg = 1;//ピンズが存在するのでフラグを立てる
		}
		//赤五筒以外のピンズを配置する
		for(j=1;j<tehai[i]+1;j++){
			if(!tehai[i]){continue;}
			paikigou += (i-10);
			paiFlg = 1;//ピンズが存在するのでフラグを立てる
		}
	}
	if(paiFlg){
		paikigou += "p";//末尾に付ける文字
		paiFlg = 0;//フラグのリセット
	}

	//ソーズの牌記号を生成する
	for(i=21;i<30;i++){
		//赤五索を配置する
		if(i==25 && red5souCount==1){//red5souCountはグローバル変数
			paikigou += "0";//赤ドラ
			paiFlg = 1;//ソーズが存在するのでフラグを立てる
		}
		//赤五索以外のソーズを配置する
		for(j=1;j<tehai[i]+1;j++){
			if(!tehai[i]){continue;}
			paikigou += (i-20);
			paiFlg = 1;//ソーズが存在するのでフラグを立てる
		}
	}
	if(paiFlg){
		paikigou += "s";//末尾に付ける文字
		paiFlg = 0;//フラグのリセット
	}

	//字牌の牌記号を生成する
	for(i=31;i<38;i++){
		for(j=1;j<tehai[i]+1;j++){
			if(!tehai[i]){continue;}
			paikigou += (i-30);
			paiFlg = 1;//字牌が存在するのでフラグを立てる
		}
	}
	if(paiFlg){
		paikigou += "z";//末尾に付ける文字
		paiFlg = 0;//フラグのリセット
	}

	return paikigou;//牌記号を返す
}
//============================================================================
//MPS形式の牌記号を生成する関数
//============================================================================
function makeMpsPaikigou(){
	var paiFlg = 0;//マンズ・ピンズ・ソウズ・字牌の有無をチェックするフラグ
	var paikigou="";
	var i,j;

	//マンズの牌記号を生成する
	for(i=1;i<10;i++){
		//赤五萬を配置する
		if(i==5 && red5manCount==1){//red5manCountはグローバル変数
			//paikigou += "赤5";//赤ドラ
			paikigou += "r5";//赤ドラ
			paiFlg = 1;//マンズが存在するのでフラグを立てる
		}
		//赤五萬以外のマンズを配置する
		for(j=1;j<tehai[i]+1;j++){
			if(!tehai[i]){continue;}
			paikigou += i;
			paiFlg = 1;//マンズが存在するのでフラグを立てる
		}
	}
	if(paiFlg){
		paikigou += "m";//末尾に付ける文字
		paiFlg = 0;//フラグのリセット
	}

	//ピンズの牌記号を生成する
	for(i=11;i<20;i++){
		//赤五筒を配置する
		if(i==15 && red5pinCount==1){//red5pinCountはグローバル変数
			//paikigou += "赤5";//赤ドラ
			paikigou += "r5";//赤ドラ
			paiFlg = 1;//ピンズが存在するのでフラグを立てる
		}
		//赤五筒以外のピンズを配置する
		for(j=1;j<tehai[i]+1;j++){
			if(!tehai[i]){continue;}
			paikigou += (i-10);
			paiFlg = 1;//ピンズが存在するのでフラグを立てる
		}
	}
	if(paiFlg){
		paikigou += "p";//末尾に付ける文字
		paiFlg = 0;//フラグのリセット
	}

	//ソーズの牌記号を生成する
	for(i=21;i<30;i++){
		//赤五索を配置する
		if(i==25 && red5souCount==1){//red5souCountはグローバル変数
			//paikigou += "赤5";//赤ドラ
			paikigou += "r5";//赤ドラ
			paiFlg = 1;//マンズが存在するのでフラグを立てる
		}
		//赤五索以外のソーズを配置する
		for(j=1;j<tehai[i]+1;j++){
			if(!tehai[i]){continue;}
			paikigou += (i-20);
			paiFlg = 1;//ソーズが存在するのでフラグを立てる
		}
	}
	if(paiFlg){
		paikigou += "s";//末尾に付ける文字
		paiFlg = 0;//ソーズのリセット
	}

	//字牌の牌記号を生成する
	for(i=31;i<38;i++){
		for(j=1;j<tehai[i]+1;j++){
			if(!tehai[i]){continue;}

			switch (i){
				case 31:
					paikigou += "東";
					break;
				case 32:
					paikigou += "南";
					break;
				case 33:
					paikigou += "西";
					break;
				case 34:
					paikigou += "北";
					break;
				case 35:
					paikigou += "白";
					break;
				case 36:
					paikigou += "發";
					break;
				case 37:
					paikigou += "中";
					break;
			}
		}
	}

	return paikigou;//牌記号を返す
}
//============================================================================
